#!/usr/bin/perl

# use wstart from wdiag package
# then grab a raw frame from:
#      tethereal -V -i eth1
# copy and paste the frame dump to a file "input"
# then use:
#      ./wdecode.pl < input

#0
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$uptime = hex($8 . $7 . $6 . $5);
$noise_up = hex($10 . $9);
$power_up = hex($12 . $11);
$atten_up = hex($14 . $13);
$sync_up = hex($16 . $15);

#16
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$noise_down = hex($2 . $1);
$power_down = hex($4 . $3);
$atten_down = hex($6 . $5);
$sync_down = hex($8 . $7);
$FEC_err = hex($12 . $11 . $10 . $9);
$CRC_err = hex($16 . $15 . $14 . $13);

#32
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$HEC_err = hex($4 . $3 . $2 . $1);
$signal_err = hex($8 . $7 . $6 . $5);
$frame_err = hex($12 . $11 . $10 . $9);
$tx_cells = hex($16 . $15 . $14 . $13);

#48
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$rx_cells = hex($4 . $3 . $2 . $1);
$invalid_cells = hex($8 . $7 . $6 . $5);
$oam_cells = hex($12 . $11 . $10 . $9);
$zero21_loopback = hex($16 . $15 . $14 . $13);

#64
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$encap_type = hex($2 . $1);
$rx_aal_pdu = hex($6 . $5 . $4 . $3);
$tx_aal_pdu = hex($10 . $9 . $8 . $7);

#80
$line = <STDIN>;

#96
$line = <STDIN>;
chomp($line);
print "$line\n";
$line =~ /^\w{4}\s{2}(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s(\w{2})\s+.{16}$/;
$eth_rx = hex($6 . $5 . $4 . $3);
$eth_tx = hex($10 . $9 . $8 . $7);
$eth_drop = hex($14 . $13 . $12 . $11);

print "Uptime: $uptime\n";
print "Noise Margin Up (dB): $noise_up\n";
print "Power Up (dB): $power_up\n";
print "Attenuation Up (dBm): $atten_up\n";
print "Sync Up (kbps): $sync_up\n";
print "Noise Margin Down (dB): $noise_down\n";
print "Power Down (dB): $power_down\n";
print "Attenuation Down (dBm): $atten_down\n";
print "Sync Down (kbps): $sync_down\n";
print "FEC Error: $FEC_err\n";
print "CRC Error: $CRC_err\n";
print "HEC Error: $HEC_err\n";
print "Signal Lost: $signal_err\n";
print "Frame Lost: $frame_err\n";
print "TX ATM Cells: $tx_cells\n";
print "RX ATM Cells: $rx_cells\n";
print "Invalid ATM Cells: $invalid_cells\n";
print "OAM Control Cells: $oam_cells\n";
print "0/21 loopback: $zero21_loopback\n";
print "Encapsulation Type: $encap_type\n";
print "rx_aal_pdu: $rx_aal_pdu\n";
print "tx_aal_pdu: $tx_aal_pdu\n";
print "Ethernet RX Frames: $eth_rx\n";
print "Ethernet TX Frames: $eth_tx\n";
print "Ethernet Frames Dropped: $eth_drop\n";

